/////////////////////////////////////////////////////////////
//                                                         //
// Copyright (c) 2007-2017 by The University of Queensland //
// Centre for Geoscience Computing                         //
// http://earth.uq.edu.au/centre-geoscience-computing      //
//                                                         //
// Primary Business: Brisbane, Queensland, Australia       //
// Licensed under the Open Software License version 3.0    //
// http://www.apache.org/licenses/LICENSE-2.0              //
//                                                         //
/////////////////////////////////////////////////////////////

#ifndef __AGEOMETRICOBJECT_H
#define __AGEOMETRICOBJECT_H

// project includes
#include "util/vector3.h"
#include "Transform.h"

// STL includes
#include <array>

class AGeometricObject
{
 public:
     AGeometricObject();
  virtual ~AGeometricObject(){};

  virtual double getDist(const Vector3&) const=0;
  virtual std::array<double,3> getDistDeriv(const Vector3&) const;
  virtual void print() const;
};

#endif// __AGEOMETRICOBJECT_H  
