#ifndef ATRANSFORMABLEGEOMETRICOBJECT_H
#define ATRANSFORMABLEGEOMETRICOBJECT_H

#include "AGeometricObject.h" // Base class: AGeometricObject
#include "geometry/Transform.h"

/*!
	Base class for geometric Objects with a transformation. 
	Class is abstract because the inherited function getDist is pure virtual. 
*/
class ATransformableGeometricObject : public AGeometricObject
{
	public:
		virtual ~ATransformableGeometricObject(){};

		// virtual void setTransformation(const Transform&)=0;
		virtual void addTransformation(const Transform&)=0;
};

#endif // ATRANSFORMABLEGEOMETRICOBJECT_H
