#ifndef __SPHERE3DFITTERNR_H
#define __SPHERE3DFITTERNR_H

// --- project includes ---
#include "geometry/Sphere.h"
#include "geometry/AGeometricObject.h"
#include "sphere_fitting/utils/mat4.h"

// --- STL includes ---
#include <valarray>
#include <iostream>

class Sphere3DFitterNR 
{
	private:
		const AGeometricObject* m_GO1; 
		const AGeometricObject* m_GO2;
		const AGeometricObject* m_GO3;
		const AGeometricObject* m_GO4;
	
		mat4 m_jacobian;
		std::valarray<double> m_x;
		std::valarray<double> m_dist;
	
		// functions
		void update_distances();
		void update_jacobian();
		double dist_norm() const;
	
	public:
		Sphere3DFitterNR(const AGeometricObject*,const AGeometricObject*,const AGeometricObject*,const AGeometricObject*);
		
		Sphere calc_fit(const Vector3&,int,double);
		
		friend std::ostream& operator << (std::ostream&, const Sphere3DFitterNR&);
};




#endif // __SPHERE3DFITTERNR_H
