#ifndef __MAT4_H
#define __MAT4_H

// STL includes
#include <valarray>
#include <iostream>

/*!
	class for a 4x4 matrix

*/
class mat4 
{
	private:
		std::valarray<double> m_mat;
		
	public:
		// types
		struct solution
		{
			std::valarray<double> data;
			bool valid;
		};
	
		mat4();
				
		inline double operator()(unsigned int i, unsigned int j) const {return m_mat[i*4+j];};
		inline double& operator()(unsigned int i, unsigned int j){return m_mat[i*4+j];};
		
		solution solve_destructive(std::valarray<double>,double); 
		std::valarray<double> operator* (const std::valarray<double>&) const;
		
		friend std::ostream& operator << (std::ostream&, const mat4&); 
};

#endif // __MAT4_H
