#ifndef __TRANSFORMABLEBOXWITHPLANES3D_H
#define __TRANSFORMABLEBOXWITHPLANES3D_H

// --- Project includes ---
#include "BoxWithPlanes3D.h"
#include "geometry/Transform.h"

/*!
  \class TransformableBoxWithPlanes3D

  A 3D box volume which can be modified by applying an (affine) transformation  
*/
class TransformableBoxWithPlanes3D : public BoxWithPlanes3D 
{
 protected:
  Transform m_transform;

 public:
  TransformableBoxWithPlanes3D();
  TransformableBoxWithPlanes3D(const Vector3&,const Vector3&);
  TransformableBoxWithPlanes3D(const TransformableBoxWithPlanes3D&);
  
  virtual ~TransformableBoxWithPlanes3D(){};

  virtual Vector3 getAPoint(int)const;
  virtual pair<Vector3,Vector3> getBoundingBox();
  virtual bool isIn(const Vector3&) const;
  virtual bool isIn(const Sphere&);
  virtual bool isFullyOutside(const Sphere&);
  virtual void addTransformation(const Transform&);
  TransformableBoxWithPlanes3D transform(const Transform&) const;

  friend ostream& operator<< (ostream&, const TransformableBoxWithPlanes3D&);
};

#endif // __TRANSFORMABLEBOXWITHPLANES3D_H
