#ifndef TRANSFORMABLEMESHVOLUME_H
#define TRANSFORMABLEMESHVOLUME_H

#include "MeshVolume.h" // Base class: MeshVolume

/*!
  Transformable version of the MeshVolume class
*/
class TransformableMeshVolume : public MeshVolume
{
public:
	TransformableMeshVolume();
	TransformableMeshVolume(const TriPatchSet&);
	TransformableMeshVolume(const TransformableMeshVolume&);
	TransformableMeshVolume(const TransformableMeshVolume&,bool);
	virtual ~TransformableMeshVolume();

public:
	virtual void addTransformation(const Transform&);
	TransformableMeshVolume transform(const Transform&) const;
	
	friend ostream& operator<< (ostream&, const TransformableMeshVolume&);
};

#endif // TRANSFORMABLEMESHVOLUME_H
