#include "matrix4.h"

Matrix4::Matrix4()
{
   m_data.fill(0.0);
}

Matrix4::Matrix4(const Matrix4& m)
{
    m_data=m.m_data;
}
    
Matrix4::~Matrix4()
{}
    
// matrix-matrix multiply
Matrix4 Matrix4::operator* (const Matrix4& m) const
{
    Matrix4 res;
    
    for(int i=0;i<4;i++){
        for(int j=0;j<4;j++){
            for(int k=0;k<4;k++){
                res.m_data[i+4*j]+=m_data[i+4*k]*m.m_data[k+4*j];
            }
        }
    }
    
    return res;
}

/*!
    return unit matrix
*/
Matrix4 Matrix4::unit() 
{
    Matrix4 res;
    
    for(int i=0;i<4;i++){
        res.m_data[5*i]=1.0;
    }
    
    return res;
}

/*!
    in-place matrix-matrix multiplication
*/
Matrix4& Matrix4::operator*= (const Matrix4& m)
{
    std::array<double,16> tmp;
    tmp.fill(0.0);
    
    for(int i=0;i<4;i++){
        for(int j=0;j<4;j++){
            for(int k=0;k<4;j++){
                tmp[i+4*j]+=m_data[i+4*k]*m.m_data[k+4*j];
            }
        }
    }
    
    m_data=tmp;
    
    return *this;
}
    

std::ostream& operator << (std::ostream& ost ,const Matrix4& m)
{
    for(int i=0;i<4;i++){
        for(int j=0;j<4;j++){
            ost << m.m_data[i+4*j] << " ";
        }
        ost << std::endl;
    } 
}