#ifndef __MATRIX4_H
#define __MATRIX4_H

// STL includes
#include <array>
#include <iostream>

/*!
    class for a 4x4 matrix to be used in transformation of homogeneous coordinates
*/
class Matrix4
{
    private:
        std::array<double,16> m_data;
    
    public:
        Matrix4();
        Matrix4(const Matrix4&);
    
        virtual ~Matrix4();
    
        static Matrix4 unit();
    
        // matrix-matrix multiply
        Matrix4 operator* (const Matrix4&) const;
        Matrix4& operator*= (const Matrix4&);
    
        // inversion
        //solution solve(double); 
    
        // access ops
        const double &operator[](int i) const {return m_data[i];}
        double& operator[](int i) {return m_data[i];}
    
        const double &operator()(int i, int j) const {return m_data[i+4*j];}     
        double &operator()(int i, int j) {return m_data[i+4*j];}
        
        friend std::ostream& operator << (std::ostream&,const Matrix4&);
    
};

#endif // __MATRIX